package somlib.som.descriptions;

import java.io.*;

public class LabelItem implements java.lang.Comparable {
/*
 * this class handles file communication for  SOM Label Files
 */

  /** Parameters:  **/
       //mandatory
  public int pos_x=-1;
  public int pos_y=-1;
  public String label=null;
  public float wgt=-1;
  public float qe=-1;

  public LabelItem(int pos_x, int pos_y, String label, float wgt) {
    this.pos_x = pos_x;
    this.pos_y = pos_y;
    this.label = label;
    this.wgt = wgt;
  }

  public LabelItem(int pos_x, int pos_y, String label, float wgt, float qe) {
    this.pos_x = pos_x;
    this.pos_y = pos_y;
    this.label = label;
    this.wgt = wgt;
    this.qe = qe;
  }

  public LabelItem(String init) {
    java.util.StringTokenizer strtok=new java.util.StringTokenizer(init);
    pos_x = Integer.parseInt(strtok.nextToken() );
    pos_y = Integer.parseInt(strtok.nextToken() );
    label = strtok.nextToken();
    wgt = Float.parseFloat(strtok.nextToken() );
    qe = Float.parseFloat(strtok.nextToken() );
  }

  public void writeDescr(BufferedWriter out) throws IOException, DescriptionException {
      if(qe >= 0)
        out.write(pos_x+" "+pos_y+" "+label+" "+wgt+" "+qe);
      else
        out.write(pos_x+" "+pos_y+" "+label+" "+wgt);
      out.newLine();
  }

  public int compareTo(java.lang.Object mpi) {
    return (pos_x - ((LabelItem)mpi).pos_x)*100000 + (pos_y - ((LabelItem)mpi).pos_y)*1000 + (int)(qe*100-((LabelItem)mpi).qe*100);
  }

}