package somlib.som.descriptions;

import java.io.*;

public class LibItem {
/*
 * here a sole book is described, so as that the LibViewer understands it
 */

  public String title=null, creator=null, subject=null, description=null, publisher=null, contributor=null, 
       date=null, type=null, format=null, identifier=null, relation=null, domain=null, size_byte=null, 
        wellthumbed=null, template=null, image_logo=null;
  public int width=-1, height=-1, dust_level=-1, XPos=-1, YPos=-1, highlighting=-1;
  public RGB color_front=null, color_top=null, color_spine=null, color_title=null, color_creator=null;
  public float  ZPos=-1;

  public LibItem() {
  }

  public void writeDescr(BufferedWriter out) throws IOException {
    if(title != null) {
      out.write("$TITLE "+ title); out.newLine();
    } 
    if(creator != null) {
      out.write("$CREATOR "+ creator); out.newLine();
    } 
    if(subject != null) {
      out.write("$SUBJECT "+ subject); out.newLine();
    } 
    if(description != null) {
      out.write("$DESCRIPTION "+ description); out.newLine();
    } 
    if(publisher != null) {
      out.write("$PUBLISHER "+ publisher); out.newLine();
    } 
    if(contributor != null) {
      out.write("$CONTRIBUTOR "+ contributor); out.newLine();
    } 
    if(width > 0) {
      out.write("$WIDTH "+ width); out.newLine();
    } 
    if(height > 0) {
      out.write("$HEIGHT "+ height); out.newLine();
    } 
    if(date != null) {
      out.write("$DATE "+ date); out.newLine();
    } 
    if(type != null) {
      out.write("$TYPE "+ type); out.newLine();
    } 
    if(format != null) {
      out.write("$FORMAT "+ format); out.newLine();
    } 
    if(identifier != null) {
      out.write("$IDENTIFIER "+ identifier); out.newLine();
    } 
    if(relation != null) {
      out.write("$RELATION "+ relation); out.newLine();
    } 
    if(size_byte != null) {
      out.write("$SIZE_BYTE "+ size_byte); out.newLine();
    } 
    if(image_logo != null) {
      out.write("$IMAGE_LOGO "+ image_logo); out.newLine();
    } 
    if(template != null) {
      out.write("$TEMPLATE "+ template); out.newLine();
    } 
    if(wellthumbed != null) {
      out.write("$WELLTHUMBED "+ wellthumbed); out.newLine();
    } 
    if(wellthumbed == null) {
      out.write("$WELLTHUMBED 0"); out.newLine();
    } 
    if(dust_level > 0) {
      out.write("$DUST_LEVEL "+ dust_level); out.newLine();
    } 
    if(dust_level <= 0) {
      out.write("$DUST_LEVEL 0"); out.newLine();
    } 
    if(color_front != null) {
      out.write("$COLOR_FRONT "+color_front.toString() ); out.newLine();
    } 
    if(color_top != null) {
      out.write("$COLOR_TOP "+color_top.toString() ); out.newLine();
    } 
    if(color_spine != null) {
      out.write("$COLOR_SPINE "+color_spine.toString() ); out.newLine();
    } 
    if(color_title != null) {
      out.write("$COLOR_TITLE "+color_title.toString() ); out.newLine();
    } 
    if(color_creator != null) {
      out.write("$COLOR_CREATOR "+color_creator.toString() ); out.newLine();
    } 
    if(highlighting > 0) {
      out.write("$HIGHLIGHTING 1"); out.newLine();
    } 
    if(highlighting <= 0) {
      out.write("$HIGHLIGHTING 0"); out.newLine();
    } 
    if(domain != null) {
      out.write("$DOMAIN "+domain ); out.newLine();
    } 
    if(XPos >= 0) {
      out.write("$XPOS "+ XPos); out.newLine();
    } 
    if(YPos >= 0) {
      out.write("$YPOS "+ YPos); out.newLine();
    } 
    if(ZPos >= 0) {
      out.write("$ZPOS "+ ZPos); out.newLine();
    }
  }

}