package somlib.som.descriptions;

import java.io.*;

public class TemplateVector {
/*
 * this class handles file communication for  SOM Unit Descriptions
 */

  /** Parameters:  **/
  public java.util.Vector items = null;
  private java.util.Vector unknown = null;
       //mandatory
  public String type=null;
  public int XDim=-1;
  public int YDim=-1;
  public int VecDim=-1;

  public TemplateVector(String type, int XDim, int YDim, int VecDim) {
    this.type=type;
    this.XDim=XDim;
    this.YDim=YDim;
    this.VecDim=VecDim;
    items = new java.util.Vector();
    this.unknown = new java.util.Vector();
  }

  public TemplateVector(String filename) throws DescriptionException {
    File file = new File(filename);
    if((!file.exists()) || (!file.canRead()))
      throw new DescriptionException("Can't read file: "+file.toString());

    items = new java.util.Vector();
    this.unknown = new java.util.Vector();
    readDescr(file);
  }

  public String endung() {
    return ".tv";
  }

  public void addItem(TvItem tvi) {
    items.add(tvi);
  }

  public void writeDescr(String filename) throws DescriptionException {
    File file = new File(filename);

    try {
      BufferedWriter out = new BufferedWriter(new FileWriter(file));

      out.write("$TYPE "+type); out.newLine();
      out.write("$XDIM "+XDim); out.newLine();
      out.write("$YDIM "+YDim); out.newLine();
      out.write("$VEC_DIM "+VecDim); out.newLine();
      for (java.util.Enumeration enum = unknown.elements(); enum.hasMoreElements(); ) {
        out.write((String)enum.nextElement()); out.newLine();
      }
      for (java.util.Enumeration enum = items.elements(); enum.hasMoreElements(); ) {
        ((TvItem)enum.nextElement()).writeDescr(out);
        out.flush();
      }

      out.close();
    } catch(IOException e) {
      throw new DescriptionException("descriptions.Node.writeDescr(): File communication failure: "+e.getMessage());
    }catch(DescriptionException e) {
      throw new DescriptionException("descriptions.Node.writeDescr(): "+e.getMessage());
    }
  }

  private void readDescr(File source) throws DescriptionException {
    if(!source.exists() || !source.canRead())
      throw new DescriptionException("Couldn't find file: "+source.toString());

    String str, teil;
    try {
      BufferedReader in = new BufferedReader(new FileReader(source));
      while ((str = in.readLine()) != null) {
        if(str.startsWith("$")) {
          teil=str.substring(1,str.indexOf(" "));

          if(teil.equals("TYPE"))
            type=str.substring(str.indexOf(" ")+1);
          else if(teil.equals("XDIM"))
            XDim=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("YDIM"))
            YDim=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("VEC_DIM"))
            VecDim=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else {
            unknown.add(str);
            System.out.println("Unknown Parameter: "+str);
          }
        } else {
          addItem(new TvItem(str));
        }
      }
      in.close();
    } catch(IOException e) {
      throw new DescriptionException("Failure communicating with file: "+e.getMessage());
    }
  }

}