package somlib.som.descriptions;

import java.io.*;

public class Training {
/*
 * this class handles file communication for  SOM Training Files
 */

  /** Parameters:  **/
  public java.util.Vector items = null;
  private java.util.Vector unknown = null;
       //mandatory
  public String type=new String("training");
  public int XDim=-1;
  public int YDim=-1;
  public int vec_dim=-1;
  public int iters=-1;

  public Training(int XDim, int YDim, int vec_dim, int iters) {
    this.XDim=XDim;
    this.YDim=YDim;
    this.vec_dim=vec_dim;
    this.iters=iters;
    items = new java.util.Vector();
    this.unknown = new java.util.Vector();
  }

  public void addItem(TrainingItem mpi) {
    items.add(mpi);
  }

  public void writeDescr(String filename) throws DescriptionException {
    File file = new File(filename);

    try {
      BufferedWriter out = new BufferedWriter(new FileWriter(file));

      out.write("$TYPE "+type); out.newLine();
      out.write("$XDIM "+XDim); out.newLine();
      out.write("$YDIM "+YDim); out.newLine();
      out.write("$VEC_DIM "+vec_dim); out.newLine();
      for (java.util.Enumeration enum = unknown.elements(); enum.hasMoreElements(); ) {
        out.write((String)enum.nextElement()); out.newLine();
      }
      for(int i=0; i<items.size(); i++) {
        ((TrainingItem)items.elementAt(i)).writeDescr(out);
      }

      out.close();
    } catch(IOException e) {
      throw new DescriptionException("somlib.som.descriptions.Training.writeDescr(): File communication failure: "+e.getMessage());
    }catch(DescriptionException e) {
      throw new DescriptionException("somlib.som.descriptions.Training.writeDescr(): "+e.getMessage());
    }
  }

}