package somlib.som.functions;

public class ENeighbor implements Neighborhood
/*
 * an actual implementation of a Neighborhood-Function;
 * the corresponding Learningrate-Function is ELearn;
 * it is called by somlib.som.functions.Functions and chosen by a String-parameter "ENeighbor"
 */
{

  private float delta0;
  private float tdelta;

  public void define(int XDim, int YDim, float delta0)
  /*
   * as it is not possible to define a constructor (due to the way the class is instantiated)
   * the initialisation has to be done here
   */
  {
    this.delta0=delta0;
    float logbasis = (float) (Math.log(XDim*YDim)* (1.0f/ Math.log(10.0))*50.0);
    tdelta = (float) Math.pow(logbasis, 1.8);
  }

  private float delta(int t) {
    return delta0* (float) Math.exp(-t / tdelta);
  }

  public float hci(int t, float distance) {
    return (float) ((float) Math.exp((-1) * distance / (2* (float) Math.pow(delta(t), 2))));
  }

  public String neighborhoodType() {
    String classname = this.getClass().getName();
    return classname.substring(classname.lastIndexOf('.')+1, classname.length());
  }

  public float neighborhoodInit() {
    return delta0;
  }

}