package somlib.som.labelling;

import java.io.*;
import java.util.*;

public class WordfileReader {
/*
 * this class handles file communication with a  Wordfile containing the labels of a vector;
 * the Wordfile is produced by the Parser; 
 * actually this is all about the SOM Template Vector File, but only the labels are needed
 */

  public static String[] loadWords(String wordfile, byte verbose) throws LabellingException {
    int vectorDimension = -1;
    String[] words = null;
    try {
      BufferedReader in = new BufferedReader(new FileReader(wordfile));
      String str;
      if (verbose > 1) System.out.println("    start: loadWords.");

      str = in.readLine(); 	// nicht gebraucht
      str = in.readLine(); 	// nicht gebraucht
      str = in.readLine(); 	// nicht gebraucht
      str = in.readLine(); 	// in dieser zeile steht anzahl der dimensionen
      vectorDimension = (new Integer(str.substring(str.indexOf(' ')+1,str.length()))).intValue();
      if(vectorDimension < 0)
        throw new LabellingException("Dimensions of word-file don't match Training-Vectors.");
      words = new String[vectorDimension];

      if (verbose > 1) System.out.println("      reading words...");
      int index;
      java.util.StringTokenizer strtok;
      for (int i=0; i<vectorDimension; i++) {
        strtok = new java.util.StringTokenizer(in.readLine());
        strtok.nextToken();    // index wird nicht gebraucht
        words[i] = strtok.nextToken();
      }
    } catch (IOException e) {
      throw new LabellingException("WordfileReader.loadWords: "+e.getMessage());
    }
    if (verbose > 1) System.out.println("    end: loadWords.");

    return words;
  }

}