package somlib.som.preprocess;

import somlib.som.descriptions.*;

public class Normalizer extends ConverterWriter
/*
 * since the writing is handled in the abstract super-class, 
 * only the converting has to be handled here
 */
{

  public Normalizer(Reader reader, somlib.textrepresentation.Logfile log, byte verbose) throws PreprocessException
  /*
   * the data to be converted and written has been read by a @reader
   */
  {
    super(reader, log, verbose);
  }

  public void convert()
  /*
   * this implementation normalizes the vectors read
   */
  {
      for (int i=0; i<reader.vecs; i++)
        reader.iv[i]=((new somlib.som.Vector(reader.iv[i], reader.labels[i])).normalize()).v;
  }

}