package somlib.som.preprocess;

import java.io.*;
import somlib.som.*;

public abstract class Reader
/*
 * in a Preprocess step, data is first read, converted and finally written
 * therefore any of the reading-steps obeys the Reader-structure
 */
{
  public somlib.textrepresentation.Logfile log = null;
  public byte verbose = 2;

  public String type;
  public int vecs; 		    // anzahl der vectoren
  public int dims;		    // dimension der vectoren
  public float[][] iv=null; 	    // Vectoren selbst
  public String[] labels=null;   // labels der Vectoren

  public Reader(String filename, somlib.textrepresentation.Logfile log, byte verbose) throws PreprocessException {
    this.log=log;
    this.verbose=verbose;

    initIVs(filename);
  }

  public abstract void initIVs(String f) throws PreprocessException;

}