package somlib.som.preprocess;

public class Vec2Vec
/*
 * this class coordinates the reading, converting and writing to the same format 
 * of input-data for a SOM Training
 */
{

  public static void main(String[] args) throws PreprocessException {
    if (args.length%2 == 1)
      usage();
    else {
      int param=0;
      String in=null, out=null;
      int verbose=1;
      boolean normalize = false;

      while(param < args.length) {      //getting the command-line parameters
        if((args[param].length()>2) || (args[param].charAt(0)!='-'))
          usage();

        switch(args[param].charAt(1)) {
          case 'i':
            in = new String(args[++param]);
            break;
          case 'o':
            out = new String(args[++param]);
            break;
          case 'n':
            if(args[++param].charAt(0) == 't')
              normalize=true;
            break;
          case 'v':
            verbose = Integer.parseInt(args[++param]);
            break;
          default:
            usage();
        }
        param++;
      }

      if(in==null)
        usage();
      if(out==null)
        out = new String(in);

      Reader reader = new VecReader(in, null, (byte)verbose);
      ConverterWriter writer;
      if(normalize)
        writer = new Normalizer(reader, null, (byte)verbose);
      else
        writer = new PlainWriter(reader, null, (byte)verbose);
      writer.writeVecInput(out);
    }
  }

  static void usage() {
    System.out.println("Usage: java somlib.som.preprocess.Vec2Vec -i <SOM-Input-Vector_in> [-o <SOM-Input-Vector_out>] [-n <normalize [t/f]>] [-v <verbosity>]");

    System.exit(1);
  }

}