package somlib.som.tools.transpose;

/**
 * Title:                                         SomLib
 * Description:Java Tools for the SomLib Project
 * Copyright:                                     Copyright (c) 2000
 * Company:                                       IFS
 * @author elan
 * @version 1.0
 */

import java.io.*;

public class FakeTemplateVectorFile {

 // when transposing an tf*idf file it is also necessary to create a new
 // template vector so that further labeling will be possible
 // this template only serves labeling and therefor is a fake.
 // the structure is the following:
 // lines 1-4 dont matter
 // line 5: "$VEC_DIM <number>
 // line 6-n: "<index> <word>
  public static void write(String[] words, String filename, byte verbose) throws TransposeException {
    try {
      if (verbose > 1) System.out.println("    start writing transposed template ...");
      File file = new File(filename);
      BufferedWriter out = new BufferedWriter(new FileWriter(file));

      out.write("$TYPE transposed-template: use only for labeling"); out.newLine();
      out.write("$XDIM ignored"); out.newLine();
      out.write("$YDIM ignored"); out.newLine();
      out.write("$VEC_DIM "+words.length); out.newLine();

      for(int i=0; i<words.length; i++) {out.write(i+" "+words[i]); out.newLine();}
      out.flush(); out.close();
      if (verbose > 1) System.out.println("    done writing transposed template.");
    } catch(IOException e) {
      throw new TransposeException("File communication failure: "+e.getMessage());
    }
  }

}