package somlib.textrepresentation;

import java.io.*;
import java.util.*;
import java.text.*;

/**
*
* @author elan
* @version 1.0
*/
public class Logfile extends Object {

  BufferedWriter out;
  Date today;
  String dateOut;
  DateFormat formatter;

  public Logfile(String fn) throws TextrepresentationException {
    if (fn != "") {
    try {
      File f = new File(fn);
      File dir = new File(fn.substring(0,fn.lastIndexOf(File.separator)));
      dir.mkdirs();
      f.createNewFile();

      String str;
      File tmpFile = File.createTempFile("log","tmp");
      BufferedReader in = new BufferedReader(new FileReader(f));
      BufferedWriter outTmp = new BufferedWriter(new FileWriter(tmpFile));
      // kopiere alles in die tmp datei

      while ((str = in.readLine()) != null) { outTmp.write(str); outTmp.newLine();}
      in.close();
      outTmp.flush(); outTmp.close();

      BufferedReader inTmp = new BufferedReader(new FileReader(tmpFile));

      out = new BufferedWriter(new FileWriter(f));
      while ((str = inTmp.readLine()) != null) { out.write(str); out.newLine();}

      inTmp.close();
      tmpFile.delete();

      formatter = DateFormat.getDateTimeInstance(DateFormat.MEDIUM, DateFormat.MEDIUM, Locale.getDefault());
      today = new Date();
      dateOut = formatter.format(today);

      out.newLine();
      out.write("New Log Session started at: "+dateOut); out.newLine();
    } catch (Exception e) {throw new TextrepresentationException("Error Logfile: " + e.getMessage());}
    }
  }

  public void append(String str) {
    if (out != null) {
    try {
      formatter = DateFormat.getTimeInstance(DateFormat.MEDIUM, Locale.getDefault());
      today = new Date();
      dateOut = formatter.format(today);

//System.out.println("log: "+dateOut + " " + str);
      out.write(dateOut + " " + str); out.newLine();
    } catch (Exception e) {System.err.println("Error with Logfile!");}
    }
  }

  public void close() {
    if (out != null) {
    try {
      out.flush();
      out.close();
    } catch (Exception e) {System.err.println("Error with Logfile!");}
    }
  }

}
