package somlib.textrepresentation;

import java.io.*;
import java.lang.*;
import java.util.*;

/**
 * handles the template vector
 *
 * @author elan
 * @version 1.0 (22.08.1999)
 */
public class TemplateVector extends Object {

/**
 *  @param filename
 *  @param tv template vector
 *  @exception PreprocessException if any error occurs
 */
  public static void store(String filename, Hashtable tv) throws TextrepresentationException {
    if(filename==null) throw new TextrepresentationException("TemplateVector: store: name for template vector needed");
    try {
      File nUrTF = new File(filename);
      int pfad;
      if((pfad = nUrTF.toString().lastIndexOf(File.separator)) > 0) {
        File dirOfnUrTF = new File(nUrTF.toString().substring(0, pfad));
        dirOfnUrTF.mkdirs();
      }
      nUrTF.createNewFile();
      ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(nUrTF));
      out.writeObject(tv);
      out.flush(); out.close();
    } catch (Exception e) {throw new TextrepresentationException("TemplateVector: store: "+e.getMessage());}
  } // store

/**
 *  @param filename
 *  @return tv template vector
 *  @exception PreprocessException if any error occurs
 */
  public static Hashtable load(String filename) throws TextrepresentationException {
    Hashtable tv = null;
    if(filename==null) throw new TextrepresentationException("TemplateVector: load: name for template vector needed");
    try {
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(filename));
      tv = (Hashtable) in.readObject();
      in.close();
    } catch (Exception e) {
      throw new TextrepresentationException("TemplateVector: load: " + e.getMessage());
    }
    return tv;
  } // load

/**
 *  @param filename
 *  @param tv template vector
 *  @exception PreprocessException if any error occurs
 */
  public static void oldToTextFile(String filename, Hashtable tv) throws TextrepresentationException 
  /* the old Version */
  {
    if (filename==null) throw new TextrepresentationException("TemplateVector: toTextFile: no filename");
    try {
      // notwendig um verzeichnis anzulegen falls es nicht existiert.
      File f = new File(filename);

      int pfad;
      if((pfad = f.toString().lastIndexOf(File.separator)) > 0) {
        File dirOff = new File(f.toString().substring(0,pfad));
        dirOff.mkdirs(); f.createNewFile();
      }

      BufferedWriter out = new BufferedWriter(new FileWriter(f));
      out.write("$words " + (tv.size()-1)); out.newLine();
      out.write("$files " + ((Integer) tv.get("$files")).intValue()); out.newLine();

      if (tv != null) {
        int i=0;
        for (Enumeration enum = tv.keys(); enum.hasMoreElements(); ) {
          String key = (String)enum.nextElement();
          if (key.substring(0,1).compareTo("$")!=0) {
            out.write(i + " " + key + " " + ((TemplateItem) tv.get(key)).toString());
            out.newLine();
            i++;
          }
        }
      } // tf nicht leer
      out.flush(); out.close();
    } catch (Exception e) {throw new TextrepresentationException("TemplateVector: toTextFile: "+e.getMessage());}
  } // oldToTextFile

/**
 *  @param filename
 *  @param tv template vector
 *  @exception PreprocessException if any error occurs
 */
  public static void toTextFile(String filename, Hashtable tv) throws TextrepresentationException
  {
    if (filename==null) throw new TextrepresentationException("TemplateVector: toTextFile: no filename");
    try {
      // notwendig um verzeichnis anzulegen falls es nicht existiert.
      File f = new File(filename);

      int pfad;
      if((pfad = f.toString().lastIndexOf(File.separator)) > 0) {
        File dirOff = new File(f.toString().substring(0,pfad));
        dirOff.mkdirs(); f.createNewFile();
      }

      BufferedWriter out = new BufferedWriter(new FileWriter(f));
      out.write("$TYPE template"); out.newLine();
      out.write("$XDIM 7"); out.newLine();
      out.write("$YDIM " + ((Integer) tv.get("$files")).intValue()); out.newLine();
      out.write("$VEC_DIM " + (tv.size()-1)); out.newLine();

      if (tv != null) {
        int i=0;
        TemplateItem ti;
        for (Enumeration enum = tv.keys(); enum.hasMoreElements(); ) {
          String key = (String)enum.nextElement();
          if (key.substring(0,1).compareTo("$")!=0) {
            ti = (TemplateItem)tv.get(key);
            out.write(i + " " + key + " " + ti.toString());
            out.write(" "+ti.min+" "+ti.max+" "+ti.getMean());
            out.newLine();
            i++;
          }
        }
      } // tf nicht leer
      out.flush(); out.close();
    } catch (Exception e) {throw new TextrepresentationException("TemplateVector: toTextFile: "+e.getMessage());}
  } // toTextFile

} // class template vector
