package somlib.textrepresentation;

import java.util.*;
import java.io.*;
import java.lang.*;

public class extractorexc 
{

  public static void main(String[] args) {
    if (args.length%2 == 1)
      usage();
    else {
      int param=0;
      String input_hgs_extractor=null;
      String input_tv_extractor=null;
      String output_extractor=null;
      boolean chkTF_extractor=false;
      boolean chkBin_extractor=false;
      boolean chkTFxIDF_extractor=false;
      int verbose=2;

      while(param < args.length) {      //getting the command-line parameters
        if((args[param].length()>2) || (args[param].charAt(0)!='-'))
          usage();

        switch(args[param].charAt(1)) {
          case 'i':
            input_hgs_extractor = new String(args[++param]);
            break;
          case 'j':
            input_tv_extractor = new String(args[++param]);
            break;
          case 'o':
            output_extractor = new String(args[++param]);
            break;
          case 't':
            if(args[++param].charAt(0) == 't')
              chkTF_extractor=true;
            break;
          case 'b':
            if(args[++param].charAt(0) == 't')
              chkBin_extractor=true;
            break;
          case 'f':
            if(args[++param].charAt(0) == 't')
              chkTFxIDF_extractor=true;
            break;
          case 'v':
            verbose = (int)args[++param].charAt(0)-(int)'0';
            break;
          default:
            usage();
        }
        param++;
      }

      if(input_hgs_extractor==null || input_tv_extractor==null || output_extractor==null)
        usage();

      extractor(input_hgs_extractor, input_tv_extractor, output_extractor, chkTF_extractor, chkBin_extractor, chkTFxIDF_extractor, verbose);
    }
  } //main

  static void usage() {
    System.out.println("Usage: somlib.textrepresentation.reducerexc -i <input_hgs_dir> -j <input_tv> -o <output_extractor> -t <chkTF [t/f]> -b <chkBin [t/f]> -f <chkTFxIDF [t/f]> [-v <verbosity>]");
    System.out.println("Default:  chkTF_extractor=true; chkBin_extractor=false; chkTFxIDF_extractor=false");

    System.exit(1);
  }


  private static void extractor(String input_hgs_extractor, String input_tv_extractor, String output_extractor, boolean chkTF_extractor, boolean chkBin_extractor, boolean chkTFxIDF_extractor, int verb)
  {
    File indir = null;
    if (input_hgs_extractor.compareTo("") != 0) { // bei input steht etwas
      indir = new File(input_hgs_extractor);
      if (!indir.exists()) { // dir existiert nicht
        System.out.println("Histograms directory does not exist (extractor).");
        System.exit(-1);
      }
    } else {
      System.out.println("Histograms directory missing (extractor).");
      System.exit(-1);
    }
    java.io.File indir2b = null;
    if (input_tv_extractor.compareTo("") != 0) { // bei input steht etwas
      indir2b = new File(input_tv_extractor);
      if (!indir2b.exists()) { // dir existiert nicht
        System.out.println("Template Vector does not exist. (extractor)");
        System.exit(-1);
      }
    } else {
      System.out.println("Template Vector missing (extractor).");
      System.exit(-1);
    }
    File outdir = null;
    if (output_extractor.compareTo("") != 0) { // bei output steht etwas
    } else {
      System.out.println("Extractor output file missing.");
      System.exit(-1);
    }
    if (!chkTF_extractor && !chkTFxIDF_extractor && !chkBin_extractor) {
        System.out.println("No save type selected (extractor).");
        System.exit(-1);
    }
    try {
      File f2 = new File(input_hgs_extractor);
      File[] fili2 = f2.listFiles();
      if (chkTFxIDF_extractor) {
        if(verb>0) System.out.println("    making TFxIDF.");
        somlib.textrepresentation.extractor.TFxLog_NdivDF_ ext1 = new somlib.textrepresentation.extractor.TFxLog_NdivDF_();
        ext1.extract(new File(output_extractor+".tfxidf"), "vec_tfxidf", fili2,TemplateVector.load(input_tv_extractor), (byte) verb,null);
        if(verb>0) System.out.println("    done TFxIDF.");
      }
      if (chkTF_extractor) {
        if(verb>0) System.out.println("    making TF.");
        somlib.textrepresentation.extractor.TF ext2 = new somlib.textrepresentation.extractor.TF();
        ext2.extract(new File(output_extractor+".tf"), "vec_tf", fili2,TemplateVector.load(input_tv_extractor), (byte) verb,null);
        if(verb>0) System.out.println("    done TF.");
      }
      if (chkBin_extractor) {
        if(verb>0) System.out.println("    making bin.");
        somlib.textrepresentation.extractor.Binary ext3 = new somlib.textrepresentation.extractor.Binary();
        ext3.extract(new File(output_extractor+".bin"), "vec_bin", fili2,TemplateVector.load(input_tv_extractor), (byte) verb,null);
        if(verb>0) System.out.println("    done bin.");
      }
    } catch (Exception e) {
      System.out.println("Extractor Error: "+e.getMessage());
      System.exit(-1);
    }
  } // extractor

}
