package somlib.textrepresentation.preprocess.bookmarks;

import java.io.*;
import somlib.textrepresentation.*;

public class URLextr {

  private BufferedReader bookmarks=null;  //destructor cares about the closing
  private Logfile log_;
  private byte verbose;

    /** only for testing reasons */
  public static void main(String[] args) {
    URLextr test = null;

    try {
      test = new URLextr((byte)1,null,"bookmark.htm");
    } catch(FileNotFoundException e) {
      System.err.println(e.getMessage());
      System.exit(-1);
    }

    URLitem urli;
    try {
      while((urli=test.getURLs()) != null)
        System.out.println(urli.url + "  -  "+urli.name);
    } catch(BookmarksException e) {
      System.err.println(e.getMessage());
      System.exit(-1);
    }

  }

  public URLextr(byte verbose, Logfile l, String bookmarkFile) throws FileNotFoundException 
  /*
    constructor, initializes the URLextr mainly by storing the path of the bookmarks-file
  */
  {
    log_=l;
    this.verbose=verbose;
    bookmarks=new BufferedReader(new FileReader(bookmarkFile));

    if(log_!=null)
      log_.append("URL-Extractor initialized");
    if (verbose > 1) 
      System.out.println("    URLextr: initialized.");
  }

  public URLitem getURLs() throws BookmarksException
  /*
    returns the next url indicated in the bookmark-file, returns null if none is left;
    expects a strict formating, so only bookmark-files by netscape are accepted,
    by overriding this very method it shouldn't be a problem though, to fit
    the functionality to another type of bookmark-file
  */
  {
    String str=null;
    int erst;

    try {
      while ((str=bookmarks.readLine()) != null) {
        if((erst=str.toLowerCase().indexOf("<a href=")) >= 0) {
          if (verbose > 2) 
            System.out.println("    URLextr: extracted name of the next site to get");
          return new URLitem(str.substring(erst+9,erst=str.indexOf("\"",erst+10)), str.substring(1+str.indexOf(">",erst), str.indexOf("<", erst)));
        }
      }
    } catch(IOException e) {
      if (verbose > 1) System.out.println("getUrls: reading bookmark file: "+e.getMessage());
      throw new BookmarksException("getUrls: reading bookmark file: "+e.getMessage());
    }

    if (verbose > 1)
      System.out.println("    URLextr: last bookmark has been given.");

    return null;
  } //getURLs

} //class

