package somlib.textrepresentation.preprocess.email.contentType;

import java.io.File;
import somlib.textrepresentation.preprocess.email.*;

/**
 * Interface to describe email types that can be handled
 *
 * @author elias
 * @version 1.0 (18.08.1999)
 */
public interface ContentType {

/**
 *  Gets plain text of the body by filtering and converting an email file.
 *  Header and any attachments are removed. Writes the subject and the converted body to a text file.
 *  @param inFileName the email file to parse
 *  @param outFile the destination file for the body of the email
 *  @param subject of the email, it is written in to the first line of the output file
 *  @exception EMailException If any error occurs (file read or write)
 *  @returns the size of the body as long
 */
  public long getBodyText(File inFileName, File outFile, String subject) throws EMailException;
  public String getDescription();

  public String contentTypeName();

}

