package somlib.ui;

import java.io.*;
import java.util.*;

public class ConfigFile
{
  File configFile=null;

    //Parameters needed:
  public int iterations=-1;
  public int xdim=-1;
  public int ydim=-1;
  public long seed=-1;
  public double neighborhood_init=-1;
  public String neighborhood_name=null;
  public double learnrate_init=-1;
  public String learnrate_name=null;
  public String mapdescr=null;
  public String qmapdescr=null;
  public String weightdescr=null;
  public String nodedescr=null;
  public double minlab=-1;
  public int maxlab=-1;
  public String html=null;
  public int verbose=0;

  public static void main(String[] args) throws IOException
  {
    somlib.ui.ConfigFile cf = new somlib.ui.ConfigFile("cnfFile.txt");
    cf.iterations=6;
    cf.xdim=4;
    //cf.ydim=5;
    cf.writeConfigFile("cnfFile.txt1");
  }

  public ConfigFile(String filename) throws IOException {
    this.configFile = new File(filename);
    if((!configFile.exists()) || (!configFile.canRead()))
      throw new IOException("Can't read file: "+configFile.toString());

    readConfigFile();
  }

  public ConfigFile() {
  }

  private void readConfigFile() throws IOException {
    if(configFile==null)
      throw new IOException("No ConfigFile given!");
    
    String str, teil;
    try {
      BufferedReader in = new BufferedReader(new FileReader(configFile));
      while ((str = in.readLine()) != null) {
        if(str.startsWith("$")) {
          teil=str.substring(1,str.indexOf(" "));

          if(teil.equals("ITERATIONS"))
            iterations=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("XDIM"))
            xdim=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("YDIM"))
            ydim=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("SEED"))
            seed=Long.parseLong(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("NEIGHBORHOOD_INIT"))
            neighborhood_init=Double.parseDouble(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("NEIGHBORHOOD_NAME"))
            neighborhood_name=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("LEARNRATE_INIT"))
            learnrate_init=Double.parseDouble(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("LEARNRATE_NAME"))
            learnrate_name=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("MAPDESCR"))
            mapdescr=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("QMAPDESCR"))
            qmapdescr=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("WEIGHTDESCR"))
            weightdescr=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("NODEDESCR"))
            nodedescr=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("MINLAB"))
            minlab=Double.parseDouble(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("MAXLAB"))
            maxlab=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("HTML"))
            html=new String(str.substring(str.indexOf(" ")+1));
          else if(teil.equals("VERBOSE"))
            verbose=Integer.parseInt(str.substring(str.indexOf(" ")+1));
          else
            System.out.println("unknown Parameter: "+teil);
        }
      }
      in.close();
    } catch(IOException e) {
      throw new IOException("Failure communicating with file: "+e.getMessage());
    }
  }

  public void writeConfigFile(String filename) throws IOException {
    this.configFile = new File(filename);

    writeConfigFile();
  }

  public void writeConfigFile() throws IOException {
    try {
      BufferedWriter out = new BufferedWriter(new FileWriter(configFile));

      if(iterations!=-1) {
        out.write("$ITERATIONS "+iterations); out.newLine();
      }
      if(xdim!=-1) {
        out.write("$XDIM "+xdim); out.newLine();
      }
      if(ydim!=-1) {
        out.write("$YDIM "+ydim); out.newLine();
      }
      if(seed!=-1) {
        out.write("$SEED "+seed); out.newLine();
      }
      if(neighborhood_init!=-1) {
        out.write("$NEIGHBORHOOD_INIT "+neighborhood_init); out.newLine();
      }
      if(neighborhood_name!=null) {
        out.write("$NEIGHBORHOOD_NAME "+neighborhood_name); out.newLine();
      }
      if(learnrate_init!=-1) {
        out.write("$LEARNRATE_INIT "+learnrate_init); out.newLine();
      }
      if(learnrate_name!=null) {
        out.write("$LEARNRATE_NAME "+learnrate_name); out.newLine();
      }
      if(mapdescr!=null) {
        out.write("$MAPDESCR "+mapdescr); out.newLine();
      }
      if(qmapdescr!=null) {
        out.write("$QMAPDESCR "+qmapdescr); out.newLine();
      }
      if(weightdescr!=null) {
        out.write("$WEIGHTDESCR "+weightdescr); out.newLine();
      }
      if(nodedescr!=null) {
        out.write("$NODEDESCR "+nodedescr); out.newLine();
      }
      if(minlab!=-1) {
        out.write("$MINLAB "+minlab); out.newLine();
      }
      if(maxlab!=-1) {
        out.write("$MAXLAB "+maxlab); out.newLine();
      }
      if(html!=null) {
        out.write("$HTML "+html); out.newLine();
      }
      if(verbose>0) {
        out.write("$VERBOSE "+verbose); out.newLine();
      }
      out.close();
    } catch(IOException e) {
      throw new IOException("File communication failure: "+e.getMessage());
    }
  }

}
